﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace CSDemoLibrary
{
	public delegate void NativeCallback(Int32 intParam, [MarshalAs(UnmanagedType.LPWStr)] string strParam);
	
	[ComVisible(true),
	GuidAttribute("3A65D04A-3F2F-4CB3-B65A-8D402B8C64CE")]
	public class MyClass
	{
		
		public unsafe int Process(
			int intValue,
			Int32 callbackPointer,
			int intParam,
			string strParam)
		{
			IntPtr ptr = new IntPtr(callbackPointer);
			NativeCallback callbackMethod = (NativeCallback)Marshal.GetDelegateForFunctionPointer(ptr, typeof(NativeCallback));
			
			callbackMethod(intParam, strParam);
			Thread.Sleep(1000);
			
			callbackMethod(25, "المرحلة الأولى");
			Thread.Sleep(1000);
			callbackMethod(50, "المرحلة الثانية");
			Thread.Sleep(1000);
			callbackMethod(75, "المرحلة الثالثة");
			Thread.Sleep(1000);
			callbackMethod(100, "المرحلة الرابعة");

			return intValue * 10;
		}
	}
}
